package org.aohe.core.utils;

import cn.hutool.core.util.RuntimeUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

import java.nio.charset.StandardCharsets;
import java.util.List;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Slf4j
public class CommandUtils {

    public static void initSanedSocket(){
        String cmdResult = execForStrUtf8("systemctl status saned.socket");
        if (StrUtil.isNotEmpty(cmdResult)) {
            String status = CommandUtils.getSanedSocketStatus(cmdResult);
            log.info("saned.socket status：{}", status);
            if (StrUtil.isNotEmpty(status) && "dead".equals(status)) {

                execForStrUtf8("systemctl start saned.socket");
                status = CommandUtils.getSanedSocketStatus(execForStrUtf8("systemctl status saned.socket"));
                if("dead".equals(status)){
                    cmdResult = execForStrUtf8Sudo("systemctl start saned.socket");
                }
                log.info("start command {}", cmdResult);
                log.info("saned.socket successfully");
            }
        }
    }

    public static String execForStrUtf8(String command){
        return RuntimeUtil.execForStr(StandardCharsets.UTF_8,command);
    }

    public static String execForStrUtf8Sudo(String command){
        return RuntimeUtil.execForStr(StandardCharsets.UTF_8,"sudo " + command);
    }

    public static String getSanedSocketStatus(String commandResult) {
        String result = "";
        String[] resultArray = commandResult.split("\n");
        List<String> list = new ArrayList<>();
        for (String item : resultArray) {
            if (item.contains("Active:")) {
                String serialItem = item.replace("*", "").replace("\t", "").replace(" ", "");
                list.add(serialItem);
            }
        }
        if (!list.isEmpty()) {
            Pattern pattern = Pattern.compile("\\((.*?)\\)");
            Matcher matcher = pattern.matcher(list.getFirst());
            if (matcher.find()) {
                result = matcher.group(1);
            }
        }
        return result;
    }

}
